/*
 * This file is part of WCX_SFF. A Windows Commander plugin for SFF files.
 * Copyright (C) 2001  Amenna Heratsini
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * email: amennah@hotmail.com
 */

#ifndef __BMP_H__
#define __BMP_H__

#include <windows.h>

void BMPencode(HANDLE handle, BYTE *image, WORD width, WORD height, WORD bpp);
// info:   write uncompressed 1-bit or 24-bit windows bitmap
// input:  handle  = output file
//         image   = (width x height) 3-byte RGB values
//         width   = width of image
//         height  = height of image
//         bpp     = bits per pixel (1 or 24)

void BMPdecode(HANDLE handle, BYTE **image);
// info:   read 1, 4, 8, 24-bit (uncompressed) or 4, 8-bit (RLE) windows bitmap
// input:  handle = input file
// output: image  = (width x height) 3-byte RGB values

int BMPinfo(HANDLE handle, WORD *width, WORD *height, WORD *bpp);
// input:  handle = input file
// output: width  = width of image
//         height = height of image
//         bpp    = bits per pixel (1, 4, 8 or 24)
// return: -255     = error
//         <sign> 0 = no compression
//         <sign> 1 = RLE 8-bit compression
//         <sign> 2 = RLE 4-bit compression
//         <sign> 3 = uncompressed bitfields  (unsupported)
//         where: <sign> = - if the file type is unsupported
//                         + if the file can be read

#endif
